//+------------------------------------------------------------------+
//|                                                 Python3Proxy.mq4 |
//|                        Copyright 2020, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2020, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict

#include <DCLib/Network/IWinSocketWrapper.mqh>
#include <DCLib/Network/WinSocketWrapper.mqh>
#include <DCLib/EALibs/Py3_Proxy_EA/Py3_Proxy_Interface.mqh>

//--- input parameters
input string EA_version = "2020Q3_Release_005";
input string Session_001 = "------------------------- Server"; // Session
input ushort ServerPort = 23456;  // Server port
input bool isLocalHostOnly = true; // Local host only
input int magicNum = 19970766; // magic number
input string Session_003 = "------------------------- EA params"; // Session
input int in_int_param_001 = 0; // Int Param 001
input double in_double_param_001 = 0.0; // Double Param 001
input datetime in_datetime_param_001 = D'1970.01.01 00:00'; // Datetime Param 001
input string in_string_param_001 = ""; // String Param 001
input bool in_bool_param_001 = false; // Bool Param 001
input string Session_002 = "------------------------- Logger"; // Session
input bool isPrintInfo = true; // Print Info
input bool isPrintDebug = false; // Print Debug
input bool isPrintWarn = false; // Print Warn
input bool isPrintTrace = false; // Print Trace

IWinSocketWrapper *g_win_soc = NULL;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
    g_win_soc = new WinSocketWrapper();

    pyAddInput_Int("Int Param 001", in_int_param_001);
    pyAddInput_Double("Double Param 001", in_double_param_001);
    pyAddInput_Datetime("Datetime Param 001", in_datetime_param_001);
    pyAddInput_String("String Param 001", in_string_param_001);
    pyAddInput_Bool("Bool Param 001", in_bool_param_001);

    return pyOnInit(g_win_soc, ServerPort, isLocalHostOnly, magicNum);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
    pyOnDeinit(reason);
    pyClear();

    if (g_win_soc)
    {
        delete g_win_soc;
        g_win_soc = NULL;
    }
}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
    //---
    pyOnTick();
}
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
{
    //---
    pyOnTimer();

}
//+------------------------------------------------------------------+
//| Tester function                                                  |
//+------------------------------------------------------------------+
double OnTester()
{
    return pyOnTester();
}
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
    //---
    pyOnChartEvent(id, lparam, dparam, sparam);
}
//+------------------------------------------------------------------+
